/*  DF Player
 *  =========
 *  Attiny85 pure chip with capacitive sensor (10MOhm)
 *  Markus Opitz 2022
 *  www.instructables.com
 */


#include "Arduino.h"
#include "SoftwareSerial.h"
#include "DFRobotDFPlayerMini.h"
#include <CapacitiveSensor.h>
CapacitiveSensor touchSensor = CapacitiveSensor(4,3);  // pin 3 to wire/foil
const int level = 55;



//MP3 Settings
SoftwareSerial mySerial(0, 1);
# define Start_Byte 0x7E
# define Version_Byte 0xFF
# define Command_Length 0x06
# define End_Byte 0xEF
# define Acknowledge 0x00 //Returns info with command 0x41 [0x01: info, 0x00: no info]


DFRobotDFPlayerMini myDFPlayer;


void setup()
{
  pinMode(1, OUTPUT);       // set pin1 as output
  mySerial.begin(9600);     // start connection
 pinMode(2, OUTPUT);
  execute_CMD(0x06, 0, 30); // Set the volume to max (30)
  delay(100);
}


void loop()
{
  
  long touchValue = touchSensor.capacitiveSensor(5); //read sensor
  if (touchValue > level) {
    digitalWrite(2, HIGH);
    delay(200);
    execute_CMD(0x01, 0, 1);        // play mp3
    //delay(2000);                  // full or a certain time

  }
  else {
    digitalWrite(2, LOW);
    delay(50);
  }
  
}




void execute_CMD(byte CMD, byte Par1, byte Par2)
// Excecute the command and parameters
{
  // Calculate the checksum (2 bytes)
  word checksum = -(Version_Byte + Command_Length + CMD + Acknowledge + Par1 + Par2);
  // Build the command line
  byte Command_line[10] = { Start_Byte, Version_Byte, Command_Length, CMD, Acknowledge,
                            Par1, Par2, highByte(checksum), lowByte(checksum), End_Byte
                          };
  //Send the command line to the module
  for (byte k = 0; k < 10; k++)
  {
    mySerial.write( Command_line[k]);
  }
}
